## This file was auto-generated by CloudCoreo CLI
## This file was automatically generated using the CloudCoreo CLI
##
## This config.rb file exists to create and maintain services not related to compute.
## for example, a VPC might be maintained using:
##

coreo_aws_ec2_securityGroups "${CLUSTER_NAME}${SUFFIX}-elb" do
  action :sustain
  description "load balance the ui and client connectinos"
  vpc "${VPC_NAME}"
  allows [ 
          { 
            :direction => :ingress,
            :protocol => :tcp,
            :ports => ${CLUSTER_ELB_TRAFFIC_PORTS},
            :cidrs => ${CLUSTER_ELB_TRAFFIC_CIDRS}
          },
          { 
            :direction => :egress,
            :protocol => :tcp,
            :ports => ${CLUSTER_ELB_TRAFFIC_PORTS_EGRESS},
            :cidrs => ${CLUSTER_ELB_TRAFFIC_CIDRS_EGRESS}
          }
    ]
end

coreo_aws_ec2_elb "${CLUSTER_NAME}${SUFFIX}-elb" do
  action :sustain
  type "internal"
  vpc "${VPC_NAME}"
  subnet "${PRIVATE_SUBNET_NAME}"
  security_groups ["${CLUSTER_NAME}${SUFFIX}-elb"]
  listeners ${ELB_LISTENERS}
  health_check_protocol 'tcp'
  health_check_port "${CLUSTER_TCP_HEALTH_CHECK_PORT}"
  health_check_timeout 5
  health_check_interval 120
  health_check_unhealthy_threshold 5
  health_check_healthy_threshold 2
end

coreo_aws_route53_record "${CLUSTER_NAME}${SUFFIX}" do
  action :sustain
  type "CNAME"
  zone "${DNS_ZONE}"
  values ["COMPOSITE::coreo_aws_ec2_elb.${CLUSTER_NAME}${SUFFIX}-elb.dns_name"]
end

coreo_aws_ec2_securityGroups "${CLUSTER_NAME}${SUFFIX}" do
  action :sustain
  description "cluster instances security group"
  vpc "${VPC_NAME}"
  allows [
          { 
            :direction => :ingress,
            :protocol => :tcp,
            :ports => ${CLUSTER_INSTANCE_TRAFFIC_PORTS},
            :cidrs => ${CLUSTER_INSTANCE_TRAFFIC_CIDRS}
          },
          { 
            :direction => :ingress,
            :protocol => :udp,
            :ports => ${CLUSTER_INSTANCE_TRAFFIC_PORTS},
            :cidrs => ${CLUSTER_INSTANCE_TRAFFIC_CIDRS}
          },
          { 
            :direction => :ingress,
            :protocol => :tcp,
            :ports => ${CLUSTER_INSTANCE_TRAFFIC_PORTS},
            :groups => ["${CLUSTER_NAME}${SUFFIX}-elb"]
          },
          { 
            :direction => :egress,
            :protocol => :udp,
            :ports => ['0..65535'],
            :cidrs => ['0.0.0.0/0']
          },
          { 
            :direction => :egress,
            :protocol => :tcp,
            :ports => ['0..65535'],
            :cidrs => ['0.0.0.0/0']
          }
    ]
end

coreo_aws_iam_policy "${CLUSTER_NAME}${SUFFIX}" do
  action :sustain
  policy_name "${CLUSTER_NAME}${SUFFIX}Role"
  policy_document <<-EOH
{
  "Statement": [
    {
      "Effect": "Allow",
      "Resource": [
          "*"
      ],
      "Action": [ 
          "autoscaling:DescribeAutoScalingGroups",
          "autoscaling:DescribeAutoScalingInstances",
          "ec2:DescribeAvailabilityZones",
          "ec2:DescribeInstanceAttribute",
          "ec2:DescribeInstanceStatus",
          "ec2:DescribeInstances",
          "ec2:DescribeTags"
      ]
    }
  ]
}
EOH
end

coreo_aws_ec2_autoscaling "${CLUSTER_NAME}${SUFFIX}" do
  action :sustain 
  minimum((${AUTOMATIC_ON_OFF} ? ((${AUTOMATIC_ON_HOUR}..(${AUTOMATIC_OFF_HOUR}-1)).include?(Time.new.getlocal("${TIMEZONE_OFFSET}").hour) ? ${AUTOSCALING_GROUP_MINIMUM} : 0) : ${AUTOSCALING_GROUP_MINIMUM}))
  maximum((${AUTOMATIC_ON_OFF} ? ((${AUTOMATIC_ON_HOUR}..(${AUTOMATIC_OFF_HOUR}-1)).include?(Time.new.getlocal("${TIMEZONE_OFFSET}").hour) ? ${AUTOSCALING_GROUP_MAXIMUM} : 0) : ${AUTOSCALING_GROUP_MAXIMUM}))
  server_definition "${CLUSTER_NAME}${SUFFIX}"
  subnet "${PRIVATE_SUBNET_NAME}"
  elbs ["${CLUSTER_NAME}${SUFFIX}-elb"]
  health_check_grace_period ${CLUSTER_HEALTH_CHECK_GRACE_PERIOD}
  upgrade({
            :upgrade_on => "dirty",
            :cooldown => ${CLUSTER_UPGRADE_COOLDOWN}
        })
end
